## Godot Builder

A base debian image, configured with tools and helpers required to build godot games in CI.

Additionally includes all tools & dependencies to build web content with Node, and Rust extensions
with Rust & emscripten

### Commands

#### godot

The docker image contains the full godot editor binary, 
available anywhere in the system referenced as `godot`.
If you extend this image to have graphical capabilities,
this can be used to launch full editor instances. Otherwise
the `--headless` option is recommended

#### godot_build

Build a godot project. Paths for this command are based on 
the _container_, not the host system, so be aware of your
volume mounts

Usage `godot_build [Output Name] [Preset Name] [Project Path]`

This command expects the given preset name to have already
been configured in your project's Export panel 
(`Project` -> `Export` in the editor menu), and that it can
locate a valid Godot project within the path. The Output name
will be used for the generated executable.

_The project path must point to a folder that **contains** a
`project.godot` file, it must not point to the file itself_

**Example**: 

Exporting a Linux build of a game mounted to the path "/var/godot_project" 

`godot_build excellent_runner Linux /var/godot_project`

#### godot_install

Typically not required in user scripts, but can be used to 
install a different version or architecture of godot

Usage: `godot_install [Godot Version] [Platform Slug]`

**Example**: 

Install the 4.3 RC 1 build for macOS 

`godot_install 4.3-rc1 macos.universal`
 
This command is most useful for the following platform slugs:
- `linux.x86_64`
- `macos.universal`
- `win64.exe`